import inject from '../vdom/inject';
import Instance from '../vdom/instance';
import ServerDriver from 'driver-server';
import Serializer from './serializer';
import { INSTANCE } from '../constant'; // Init

inject({
  driver: ServerDriver
});
export default {
  create: function create(element) {
    var container = ServerDriver.createBody();
    var rootComponent = Instance.mount(element, container, {});

    var renderedComponent = rootComponent.__getRenderedComponent();

    renderedComponent.toJSON = function () {
      return new Serializer(container).toJSON();
    };

    renderedComponent.getInstance = function () {
      return renderedComponent[INSTANCE];
    };

    renderedComponent.update = function (element) {
      Instance.mount(element, container, {});
    };

    renderedComponent.unmount = function () {
      var component = Instance.get(container);

      if (!component) {
        return false;
      }

      Instance.remove(container);

      component._internal.unmountComponent();

      return true;
    };

    return renderedComponent;
  }
};