"use strict";

exports.__esModule = true;
exports.shared = exports.PureComponent = exports.useImperativeHandle = exports.useReducer = exports.useMemo = exports.useCallback = exports.useRef = exports.useLayoutEffect = exports.useEffect = exports.useContext = exports.useState = void 0;

var _createElement2 = _interopRequireDefault(require("./createElement"));

exports.createElement = _createElement2.default;

var _createContext2 = _interopRequireDefault(require("./createContext"));

exports.createContext = _createContext2.default;

var _createRef2 = _interopRequireDefault(require("./createRef"));

exports.createRef = _createRef2.default;

var _forwardRef2 = _interopRequireDefault(require("./forwardRef"));

exports.forwardRef = _forwardRef2.default;

var _hooks = require("./hooks");

exports.useState = _hooks.useState;
exports.useContext = _hooks.useContext;
exports.useEffect = _hooks.useEffect;
exports.useLayoutEffect = _hooks.useLayoutEffect;
exports.useRef = _hooks.useRef;
exports.useCallback = _hooks.useCallback;
exports.useMemo = _hooks.useMemo;
exports.useReducer = _hooks.useReducer;
exports.useImperativeHandle = _hooks.useImperativeHandle;

var _memo2 = _interopRequireDefault(require("./memo"));

exports.memo = _memo2.default;

var _fragment = _interopRequireDefault(require("./fragment"));

exports.Fragment = _fragment.default;

var _render2 = _interopRequireDefault(require("./render"));

exports.render = _render2.default;

var _component = _interopRequireWildcard(require("./vdom/component"));

exports.Component = _component.default;
exports.PureComponent = _component.PureComponent;

var _version2 = _interopRequireDefault(require("./version"));

exports.version = _version2.default;

var _host = _interopRequireDefault(require("./vdom/host"));

var _instance = _interopRequireDefault(require("./vdom/instance"));

var _element = _interopRequireDefault(require("./vdom/element"));

var _flattenChildren = _interopRequireDefault(require("./vdom/flattenChildren"));

var _index = _interopRequireDefault(require("./devtools/index"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shared = {
  Host: _host.default,
  Instance: _instance.default,
  Element: _element.default,
  flattenChildren: _flattenChildren.default
};
exports.shared = shared;

if (process.env.NODE_ENV !== 'production') {
  /* global __RAX_DEVTOOLS_GLOBAL_HOOK__ */
  if (typeof __RAX_DEVTOOLS_GLOBAL_HOOK__ !== 'undefined' && typeof __RAX_DEVTOOLS_GLOBAL_HOOK__.inject === 'function') {
    __RAX_DEVTOOLS_GLOBAL_HOOK__.inject(_index.default);
  }

  if (typeof window !== 'undefined') {
    if (window.__RAX_INITIALISED__) {
      console.error('Warning: more than one instance of Rax has been initialised, this could lead to unexpected behaviour.');
    }

    window.__RAX_INITIALISED__ = true;
  }
}