"use strict";

exports.__esModule = true;
exports.isNull = isNull;
exports.isFunction = isFunction;
exports.isObject = isObject;
exports.isPlainObject = isPlainObject;
exports.isArray = isArray;
exports.isString = isString;
exports.isNumber = isNumber;
exports.EMPTY_OBJECT = exports.NOOP = void 0;

function isNull(obj) {
  return obj === null;
}

function isFunction(obj) {
  return typeof obj === 'function';
}

function isObject(obj) {
  return typeof obj === 'object';
}

function isPlainObject(obj) {
  return EMPTY_OBJECT.toString.call(obj) === '[object Object]';
}

function isArray(array) {
  return Array.isArray(array);
}

function isString(string) {
  return typeof string === 'string';
}

function isNumber(string) {
  return typeof string === 'number';
}

var NOOP = function NOOP() {};

exports.NOOP = NOOP;
var EMPTY_OBJECT = {};
exports.EMPTY_OBJECT = EMPTY_OBJECT;