"use strict";

exports.__esModule = true;
exports.default = Element;

var _checkPropTypes = _interopRequireDefault(require("prop-types/checkPropTypes"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Element(type, key, ref, props, owner) {
  var element = {
    // Built-in properties that belong on the element
    type: type,
    key: key,
    ref: ref,
    props: props,
    // Record the component responsible for creating this element.
    _owner: owner
  };

  if (process.env.NODE_ENV !== 'production') {
    var propTypes = type.propTypes; // Validate its props provided by the propTypes definition

    if (propTypes) {
      var displayName = type.displayName || type.name;
      (0, _checkPropTypes.default)(propTypes, props, 'prop', displayName);
    } // We make validation flag non-enumerable, so the test framework could ignore it


    Object.defineProperty(element, '__validated', {
      configurable: false,
      enumerable: false,
      writable: true,
      value: false
    }); // Props is immutable

    if (Object.freeze) {
      Object.freeze(props);
    }
  }

  return element;
}

;