"use strict";

exports.__esModule = true;
exports.default = flattenChildren;

var _types = require("../types");

function traverseChildren(children, result) {
  if ((0, _types.isArray)(children)) {
    for (var i = 0, l = children.length; i < l; i++) {
      traverseChildren(children[i], result);
    }
  } else {
    result.push(children);
  }
}

function flattenChildren(children) {
  if (children == null) {
    return children;
  }

  var result = [];
  traverseChildren(children, result); // If length equal 1, return the only one.

  return result.length - 1 ? result : result[0];
}