"use strict";

exports.__esModule = true;
exports.default = performInSandbox;
exports.handleError = handleError;

var _getNearestParent = _interopRequireDefault(require("./getNearestParent"));

var _scheduler = require("./scheduler");

var _constant = require("../constant");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function performInSandbox(fn, instance, callback) {
  try {
    return fn();
  } catch (e) {
    if (callback) {
      callback(e);
    } else {
      handleError(instance, e);
    }
  }
}

function handleError(instance, error) {
  var boundary = (0, _getNearestParent.default)(instance, function (parent) {
    return parent.componentDidCatch;
  });

  if (boundary) {
    (0, _scheduler.scheduleLayout)(function () {
      var boundaryInternal = boundary[_constant.INTERNAL]; // Should not attempt to recover an unmounting error boundary

      if (boundaryInternal) {
        performInSandbox(function () {
          boundary.componentDidCatch(error);
        }, boundaryInternal.__parentInstance);
      }
    });
  } else {
    // Do not break when error happens
    (0, _scheduler.scheduler)(function () {
      throw error;
    }, 0);
  }
}