"use strict";

exports.__esModule = true;
exports.default = void 0;

var _types = require("../types");

function shouldUpdateComponent(prevElement, nextElement) {
  var prevEmpty = (0, _types.isNull)(prevElement);
  var nextEmpty = (0, _types.isNull)(nextElement);

  if (prevEmpty || nextEmpty) {
    return prevEmpty === nextEmpty;
  }

  if ((0, _types.isArray)(prevElement) && (0, _types.isArray)(nextElement)) {
    return true;
  }

  var isPrevStringOrNumber = (0, _types.isString)(prevElement) || (0, _types.isNumber)(prevElement);

  if (isPrevStringOrNumber) {
    return (0, _types.isString)(nextElement) || (0, _types.isNumber)(nextElement);
  } else {
    // prevElement and nextElement could be array, typeof [] is "object"
    return (0, _types.isObject)(prevElement) && (0, _types.isObject)(nextElement) && prevElement.type === nextElement.type && prevElement.key === nextElement.key;
  }
}

var _default = shouldUpdateComponent;
exports.default = _default;